﻿// PoemsInfo.jsx
//
// Получение информации об объёме стихотворного текста: число строк, и  этот же объём в учетно-издательских листах (число строк, делённое на 700)
// Предполагается, что стихотворная строка -- это или однострочный абзац, или строка, в конце которой есть разрыв строки (Shift+Enfer).
// На указанных пользователем страницах анализируются все строки. Критерием строки является наличие одного из знаков набора mySearchedBreaks,
// предваряемого одним из символов набора mySearchedCharacters. 
// Поскольку после тире должна быть отбивка, то не исключено, что эта отбивка может оказаться перед знаком перевода строки.
// Поэтому программа терпимо относится к случайно оставленным одиночным пробелам в конце строки,
// возможно, есть еще случаи, когда в конце стихотворной строки допустим один (но только один!) пробел.
// Проверка на наличие такого возможного пробела выполняется операндом (\\s?) в строке mySearchedCharacters.
// При верстке стихов одно четверостишие от другого обычно отбивают нажатием клавиши перевода строки.
// Появляющиеся при этом пустые строки не учитываются при подсчете числа строк текста.
// Повторяющиеся в конце текстовой цепочки переводы строки, пробелы и пробельные шпации  удаляются. Это не влияет на вид верстки.
// Учитываются только строки, стиль которых совпадает с одним из стилей абзаца, помещенных пользователем в правый столбец меню.
// Для переноса стиля из одного столбца в другой надо или щёлкнуть дважды на названии стиля,
// или, выделив стиль одним щелчком, нажать на кнопку [ >> ] (для переноса в правый столбец) 
// или на кнопку [ << ] (для возврата в левый столбец).
// Когда стиль абзаца найденной строки совпадает с одним из выбранных пользователем, счетчик строк увеличивается на единицу.
//
//  Диалог построен на базе учебного скрипта WorkWithMenu.jsx, сделанного Борисом Кащеевым.
//
// Adobe InDesign CS3, CS4, CCxxxx.
// 
// © Михаил Иванюшин, 2010-2022  |  http://adobeindesign.ru   |  https://dotextok.ru  |  dotextok@gmail.com

var myCurrentVersionData_xx_xx_xx = "01.03.2022";
var programTitul = "Информация о стихотворном тексте";
var infoFileNamePrefix = "Poems#";
//  Исходные массивы:
var myArray1=[];
var myArray2=[];

////
var ProgressBar = function(title) { // ProgressBar
     var w = new Window('palette', title, {x:0, y:0, width:700, height:42},{closeButton: true}),       
          pb = w.add('progressbar', {x:20, y:12, width:660, height:12});
          w.center();
     this.reset = function(maxValue) {
          pb.value = 0;
          pb.maxvalue = maxValue;
          w.show();
          w.update();
      }; 
     this.hit = function() {pb.value += 1; w.update();};
     this.close = function() {w.close();};
} // ProgressBar
////////

mySearchedCharacters = '(\\d|[\\l\\u]|~e|\\)|\\]|\\}|\\-|~_|~=|~-|~~|~{|~}|«|»|~[|~]|~"|~\'|>|[.,:;!?*+=/])(\\s?)';
mySearchedBreaks = '(\\r|\\n)';
//mySearchedBreaks = '(\\r|\\n|~M|~R|~P|~L|~E|~k)';
myEndPoemLineSearchSample = mySearchedCharacters + mySearchedBreaks;
//     \\d     - цифра
//    [\\l\\u] - прописная или строчная буква
//    ~e     - многоточие
//    \\)      - закрывающая круглая скобка
//    \\]      - закрывающая квадратная скобка
//    \\}     - закрывающая фигурная скобка
//    \\-     - перенос
//    ~_    - тире
//    ~=   - минус
//    ~-    - дискреционный перенос
//    ~~    - неразрывный перенос
//    ~{    - открывающая двойная кавычка
//    ~}    - закрывающая двойная кавычка
//    ~[    - открывающая одиночная кавычка
//    ~]    - закрывающая одиночная кавычка
//    ~"   - обычная двойная кавычка
//    ~\'   - обычная одиночная кавычка
//     >    - знак 'больше' (иногда используется как закрывающая скобка)
//  [.,:;!?*+=/] - знаки пунктуации и всякие неучтенные ранее символы
/////////////////////////////////
//    \\r|\\n|~M|~R|~P|~L|~E|~k - варианты окончания строки, разрыва фрейма, колонки, страницы

getDialog = function(myAr1, myAr2,myLastNumber) { // dialog
var w = new Window( 'dialog', programTitul,undefined, {resizeable:false, maximizeButton:false, minimizeButton:false} );
w.orientation = 'column';
w.add("statictext", undefined,  'Поместите в правую колонку cтили, которыми оформлены стихи');
w.listPnl = w.add("group");
w.listPnl.orientation = 'row';
w.alignChildren = ["fill","fill"];
// Добавляем первый список в панель
w.listPnl.listBox1 = w.listPnl.add( 'listbox', [0, 0, 260, 200] );
var items1=new Array;
// Заполняем первый список
for(var i=0; i<myAr1.length; i++) { items1[i] = w.listPnl.listBox1.add( 'item', myAr1[i]) }
// Добавляем группу кнопок в панель
var g = w.listPnl.add( 'group' );
g.orientation = 'column';
// Добавляем кнопку 'Слева направо'
w.listPnl.leftrightButton=g.add( 'button', undefined, ' >> ' );
// Реакция на нажатие:
w.listPnl.leftrightButton.onClick = function() {
	var sel1 = w.listPnl.listBox1.selection;
	if(sel1 != null) {
		w.listPnl.listBox2.add('item', sel1);
		w.listPnl.listBox1.remove(sel1); 
		}
} //function
// Добавляем кнопку 'Справа налево'
w.listPnl.rightleftButton=g.add( 'button', undefined, ' << ' );
// Реакция на нажатие:
w.listPnl.rightleftButton.onClick = function() {
var sel2 = w.listPnl.listBox2.selection;
	if(sel2 != null) {
		w.listPnl.listBox1.add('item', sel2);
		w.listPnl.listBox2.remove(sel2); 
		}
} //function
// Добавляем в панель второй список
w.listPnl.listBox2 = w.listPnl.add( 'listbox', [0, 0, 260, 200]);
var items2=new Array;
// Реакция на двойной щелчок в первом списке
w.listPnl.listBox1.onDoubleClick = function() {
	var sel1 = w.listPnl.listBox1.selection;
	if(sel1 != null)  {
		w.listPnl.listBox2.add('item', sel1);
		w.listPnl.listBox1.remove(sel1); }
} // function
// Реакция на двойной щелчок во втором списке
w.listPnl.listBox2.onDoubleClick = function() {
var sel2 = w.listPnl.listBox2.selection;
if(sel2 != null) {
	w.listPnl.listBox1.add('item', sel2);
	w.listPnl.listBox2.remove(sel2); 
	}
} // function

w.myLines = w.add('group', undefined, '');
w.myNmrs = w.add('group', undefined, '');
w.myNmrs.alignChildren = "left";		
w.myNmrs.orientation = "row";
w.myNmrs.l = w.myLines.add('group');
w.myNmrs.m = w.myLines.add('group');
w.myNmrs.r = w.myLines.add('group');
var editFieldSize = [50, 5, 100, 25];
w.myNmrs.l.st = w.myNmrs.add('statictext', undefined, "Номер первой страницы");
w.myNmrs.l.et = w.myNmrs.add("edittext {justify: 'center'}", editFieldSize);
w.myNmrs.l.et.text = 1;
w.myNmrs.r.st = w.myNmrs.add('statictext', undefined, "Номер последней страницы");
w.myNmrs.r.et = w.myNmrs.add("edittext {justify: 'center'}", editFieldSize);	
w.myNmrs.r.et.text = myLastNumber;

// ——————————————————————
//Добавляем кнопки OK и Cancel как группу объектов окна w
//——————————————————————
var g = w.add( 'group' );
var buttonSize = [0,0,275,28];
g.alignChildren = ["centred","centred"];
w.okButton = g.add( 'button', buttonSize, 'OK' );
w.okButton.onClick = function() {
this.window.close( 1 );
}
w.infoButton = g.add( 'button', [0,0,28,28], '?' );
w.canButton = g.add( 'button', buttonSize, 'Cancel' );
w.canButton.onClick = function() {
this.window.close( 2 );
}
///
w.infoButton.onClick = function() {
var info_Line = "Получение информации об объёме стихотворного текста:\nЧисло строк, и  этот же объём в учётно-издательских листах (число строк, делённое на 700).\nПредполагается, что стихотворная строка — это или однострочный абзац, или строка, в конце которой есть разрыв строки (Shift+Enfer).\nНа указанных пользователем страницах анализируются все строки. Критерием строки является наличие одного из знаков набора mySearchedBreaks, предваряемого одним из символов набора mySearchedCharacters. Поскольку после тире должна быть отбивка, то не исключено, что эта отбивка может оказаться перед знаком перевода строки. Поэтому программа терпимо относится к случайно оставленным одиночным пробелам в конце строки, возможно, есть еще случаи, когда в конце стихотворной строки допустим один (но только один!) пробел.\n\nПроверка на наличие такого возможного пробела выполняется операндом (\\s?) в строке mySearchedCharacters.\n\nПри верстке стихов одно четверостишие от другого обычно отбивают нажатием клавиши перевода строки. Появляющиеся при этом пустые строки не учитываются при подсчёте числа строк текста. Повторяющиеся в конце текстовой цепочки переводы строки, пробелы и пробельные шпации  удаляются. Обычно это не влияет на вид вёрстки. Учитываются только строки, стиль которых совпадает с одним из стилей абзаца, помещенных пользователем в правый столбец меню.\n\nДля переноса стиля из одного столбца в другой надо или щёлкнуть дважды на названии стиля, или, выделив стиль одним щелчком, нажать на кнопку [ >> ] (для переноса в правый столбец) \nили на кнопку [ << ] (для возврата в левый столбец). Когда стиль абзаца найденной строки совпадает с одним из выбранных пользователем, счетчик строк увеличивается на единицу.\n\nДиалог построен на базе учебного скрипта WorkWithMenu.jsx, сделанного Борисом Кащеевым.\n\nAdobe InDesign CS3, CS4, CCxxxx.\n\n© Михаил Иванюшин, 2010-2022  |  http://adobeindesign.ru  |  https://dotextok.ru  |  dotextok@gmail.com";
alert(info_Line, programTitul);
}
///
return w;
} // dialog
// ========= Основная программа ===========
if (app.documents.length == 0) { 
    alert("Нет открытых документов.",programTitul);   
    exit();
    }
var noName = false;
try { var myDocPath = app.documents[0].filePath; } // если документ не сохранён, маршрут не сообщается
catch(e) {
   alert("Это только что созданный и ещё ни разу не сохранённый файл.\nДайте ему имя.",programTitul);   
   noName = true;
    }
if (noName) {
    try { app.documents[0].save(); }
    catch (e) {
         alert("Файл не был сохранён с новым именем.",programTitul);
        exit(); 
        }
    }
var parseIntAppVersion = parseInt (app.version); 
var myDoc = app.activeDocument;
var mySelection = app.selection[0];   
var myNumberOfPoemLines = 0;
var myCurrPageNumber = 0;
var myFoundSamples = new Array;
var myTextInCurrentFrame;
var myCounterOfTextFrames;
var myParaStyleOfFoundSamples;
var myChar;
var myUsedParaStylesInLine;
var myInfoColorSample = new Array;
// myInfoColorSample — шаблон цвета для myColorForMarkPoemLines
//myInfoColorSample = [0, 100, 100, 0]; 
myInfoColorSample = [0, 0, 0, 100]; 
var myParaStyleNames = new Array;
var myColor;
var myName;
myColorName = "myColorForMarkPoemLines";
///////////////////////////////////////////////////////////
	var myDoc = app.documents[0];
	if (myDoc.paragraphStyles.length < 3) {alert ("Нет созданных пользователем стилей.",programTitul); exit();}	
	for (i=2; i< myDoc.paragraphStyles.length; i++) { myParaStyleNames.push(myDoc.paragraphStyles.item(i).name) } // перечень всех стилей документа, кроме [Basic Paragraph]
	var w = getDialog(myParaStyleNames, myArray2,myDoc.pages.length);
	w.center();
	if ( w.show() == 1 ) { // show 
		myArray2 = w.listPnl.listBox2.items;
		if (myArray2.length == 0) {alert ("Не выбраны стили.",programTitul); exit();}
		
		var myStartNumber = Number(w.myNmrs.l.et.text);
		var myEndNumber = Number(w.myNmrs.r.et.text);
		if ((myStartNumber < 1) || (myEndNumber < 1))  {alert ("Номер страницы не может быть отрицательным или равным нулю.",programTitul); exit();}		
		if ((myStartNumber > myDoc.pages.length) || (myEndNumber > myDoc.pages.length))   {alert ("Указан несуществующий номер страницы.",programTitul); exit();}		
		if (myStartNumber > myEndNumber)  {alert ("Конечный номер страницы меньше начального.",programTitul); exit();}
		
		var myUsedParaStylesInLine = myArray2.toString(); // массив имен выбранных объединен в одну строку для последующего поиска
		var myUsedParaStylesForInfoArray = myUsedParaStylesInLine.split(',');
		var myUsedParaStylesForInfo = myUsedParaStylesForInfoArray.join("\n   ");
///////////////////////////////////
    try { myDoc.colors.item(myColorName).remove(); } // если такой цвет случайно остался, он удаляется 
    catch (e)  { a=0; }
    try{ 
        myColor = myDoc.colors.item(myColorName).name;
    }  
    catch (myError) { 
        myColor = myDoc.colors.add ({name:myColorName, model:ColorModel.process, space:ColorSpace.CMYK, colorValue:myInfoColorSample}); 
    } 	
    var pBar = new ProgressBar(programTitul); 
    pBar.reset(myDoc.pages.length);   // параметром прогресс-бара будет число страниц документа
    for ( j= 0; j < myDoc.pages.length; j++, pBar.hit()) { // Pages 
        if (j+1 < myStartNumber) continue; // пока не дошли до страницы начала подсчета строк
        if (j+1 > myEndNumber) break; // заданный диапазон пройден
        myCounterOfTextFrames = myDoc.pages[j].textFrames.length;
        for (t = 0; t < myCounterOfTextFrames; t++) { // Frames
            myTextInCurrentFrame = myDoc.pages[j].textFrames[t];
            if (myTextInCurrentFrame.characters.length == 0) continue; // пустые фреймы пропускаются  
            if (myTextInCurrentFrame.characters[-1].fillColor.name == myColorName) break; // строки этого текстового фрейма уже учтены
            myTextInCurrentFrame.select();	
            myLocalParentStory = myTextInCurrentFrame.parentStory;
            if (myLocalParentStory.overflows == true)  { // 
                pBar.close();                 
                if (parseIntAppVersion > 6) myCurrPageNumber = myTextInCurrentFrame.parentPage.name;
                else myCurrPageNumber = myTextInCurrentFrame.parent.name;                   
                alert("Обнаружено переполнение в текстовой цепочке, проходящей через страницу " +myCurrPageNumber + ".",programTitul);
                exit();
            }  //
            // ...удаляются пробелы/пробельные шпации в конце статьи...//
            app.findGrepPreferences.findWhat = '\\s';	
            do {
                    myFoundSamples = myLocalParentStory.characters.lastItem().findGrep(); 
                    if (myFoundSamples.length != 0)  {
                        myLocalParentStory.characters.lastItem().remove(); 
                        myLocalParentStory.recompose();
                    }
            }	
            while (myFoundSamples.length != 0);
            //......//
            app.findGrepPreferences = NothingEnum.nothing;
            app.findGrepPreferences.findWhat = myEndPoemLineSearchSample;				
            myFoundSamples = myLocalParentStory.findGrep();
            for (k = 0; k < myFoundSamples.length; k++) { // FoundSample
                var paraPageName = getNumberpageOfPara(myFoundSamples[k]);
                if (paraPageName != myCurrPageNumber) { // next stepByStep
                    myCurrPageNumber = paraPageName;
                }  // next stepByStep
                if ((myCurrPageNumber >= myStartNumber) && (myCurrPageNumber <= myEndNumber)) { // S-C-E
                    myParaStyleOfFoundSamples = myFoundSamples[k].appliedParagraphStyle;
                    if (myUsedParaStylesInLine.search(myParaStyleOfFoundSamples.name) != -1) { 
                        myNumberOfPoemLines++;  
                        myFoundSamples[k].fillColor = myColorName;                       
                        }
                }  // S-C-E
                else { continue; }
            } // FoundSample
        // Проверка в рамках { FoundSample } потенциально может потерять последнюю стихотворную строку, 
        // если её последний знак -- это не знак перевода строки (или разрыва фрейма/колонки и пр.).
        // Для контроля этой потери нужны дополнительные шаги.
            app.findGrepPreferences = NothingEnum.nothing;
            app.findGrepPreferences.findWhat = mySearchedBreaks;	
            myChar = myLocalParentStory.characters.lastItem();
            myFoundSamples = myChar.findGrep();
            if (myFoundSamples.length == 1) break; // был найден какой-то из знаков перевода/разрыва строки или один из символов перехода в следующий фрейм, колонку, страницу...
            else { // last line without Enter
                app.findGrepPreferences.findWhat = mySearchedCharacters;	
                myFoundSamples = myChar.findGrep();	
                if (myFoundSamples.length == 0) break; // последний знак фрейма или статьи не входит в перечень искомых знаков	
                myColor = myChar.fillColor;
                if (myColor.name == myColorName) break; // эта строка была учтена раньше          
                myParaStyleOfFoundSamples = myChar.appliedParagraphStyle;
                if (myUsedParaStylesInLine.search(myParaStyleOfFoundSamples.name) != -1 ) { // count++
                    myNumberOfPoemLines++; 
                    myChar.fillColor = myColorName;                   
                } // count++
            } // last line without Enter
        myLocalParentStory.characters.itemByRange(0,-1).fillColor = myColorName; // строки этой статьи уже учтены
        } // Frames
    } // Pages	
     pBar.close(); 
    myDoc.select(NothingEnum.nothing); // снимем выделение     
    myDoc.colors.item(myColorName).remove(); // цвет маркировки найденных строк теперь не нужен
    var text = "\nНачальная страница: " + myStartNumber + ", конечная страница: " + myEndNumber +
    ".\nВыбранные стили:\n" + myUsedParaStylesForInfo + "\n\nЧисло строк, оформленных выбранными стилями: " +myNumberOfPoemLines +
    "\nЧисло учётно-издательских листов этого текста: " + (myNumberOfPoemLines/700).toFixed(1) + "."; 
    var myScriptFile = myGetScriptPath();
    var rezFileName = infoFileNamePrefix + decodeURI(myDoc.name).split(".indd")[0] + ".txt";
    var myScriptFolder = decodeURI(myScriptFile.path);
    var myFilePath = decodeURI(myScriptFolder + "/Info/" + rezFileName);  
    var rezFile = new File (myFilePath);
    rezFile.open("w");
    rezFile.writeln(rezFileName + "\r-------\r" + text);
    rezFile.close();
    alert (text + "\r\rИнформация сохранена в текстовом файле\r" + rezFileName + "\rв папке 'Info'.\rОна в той же папке, где скрипт.", programTitul);
    //rezFile.execute();    
    exit();	   	
    } // show
///             
function getNumberpageOfPara(para) { // getNumberpageOfPara
if (parseIntAppVersion > 6) return Number(para.parentTextFrames[0].parentPage.name); else Number(para.parentTextFrames[0].parent.name);
} // getNumberpageOfPara   
////
function myGetScriptPath() {
try { return app.activeScript; }
catch(e) { return File(e.fileName); }
}
/////
