﻿// Rus&ColoredForeignText.jsx

// Подсчет объема русского и иностранного текста в авторских листах.
// Первоначально скрипт был сделан для обработки текстов на русском и китайском языке.
// Чужеземный текст надо отметить цветом 'ForeignTextColor' (переменная specColor).
// Число знаков в авторском листе с русским текстом указано в переменной russianAS, это  40 тыс. знаков.
// Число знаков в авторском листе с иностранным текстом, это переменная foreignAS. Тут, видимо, возможны варианты, так для китайского языка это 10 тыс. знаков.
// Информация о результате будет в txt-файле, название которого начинаетс с  'Rus&ForLng#' (переменная infoFileNamePrefix), а потом идёт название обрабатываемого файла и расширение '.txt'.
// Например, после обработки файла 'medicina.indd' результат обработки будет помещён в файл 'Rus&ForLng#medicina.txt'.
// Этот файл в папке 'Info', она в той же папке, где скрипт.

// © Михаил Иванюшин  |  https://dotextok.ru   |   2021-2022  |   dotextok@gmail.com

//////////////////////////////////

var programTitul = "Объём текста на двух языках";
var specColor = "ForeignTextColor";
var russianAS = 40000;
var foreignAS = 10000;
var infoFileNamePrefix = "Rus&ForLng#";
//////////////////////////////////
var ProgressBar = function(title) { // ProgressBar
var w = new Window('palette', title, {x:0, y:0, width:740, height:45},{closeButton: true}),
pb = w.add('progressbar', {x:20, y:15, width:700, height:12}),
st = w.add('statictext', {x:20, y:12, width:700, height:20});
st.justify = 'left';
w.center();
this.reset = function(msg,maxValue) {
    st.text = msg;
    pb.value = 0; 
    pb.maxvalue = maxValue;
    w.show();
    w.update();
    };
this.set = function(value) {
    pb.value = value;
    w.show();
    w.update();
    };
this.hit = function() {++pb.value; w.update();};
this.hide = function() {w.hide();};
this.close = function() {w.close();};
this.info = function(msg)  {
    st.text = msg;
    w.show();
    w.update();
    };
} // ProgressBar
////////////////////////////

app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll; // см. http://adobeindesign.ru/2008/10/24/restore-ui/ 
if (app.documents.length == 0) {
    alert ("Нет открытых документов.",programTitul);
    exit();
    }
if (app.activeDocument.colors.item(specColor).isValid == false) {
     alert ("В файле нет цвета '" + specColor + "'.",programTitul);
    exit();   
    }
var noName = false;
try { var myDocPath = app.documents[0].filePath; } // если документ не сохранён, маршрут не сообщается
catch(e) {
   alert("Это только что созданный и ещё ни разу не сохранённый файл.\nДайте ему имя.",programTitul);   
   noName = true;
    }
if (noName) {
    try { app.documents[0].save(); }
    catch (e) {
         alert("Файл не был сохранён с новым именем.",programTitul);
        exit(); 
        }
    }
var myDoc = app.documents[0];
sel = app.selection[0];
var docName = infoFileNamePrefix + decodeURI(myDoc.name).split(".indd")[0] + ".txt";
if ((sel == null) || (sel.hasOwnProperty("texts") != true) || ((sel.hasOwnProperty("texts") == true) && (sel.constructor.name == "TextFrame"))) { // == null
    alert("Выделите текст для обработки. Поставьте курсор в текст для обработки всего материала.",programTitul);
    exit();    
    }  // == null
var story = sel.parentStory;
if (sel.constructor.name == "InsertionPoint") { story.characters.itemByRange(0,-1).select(); sel = app.selection[0]; }
var myStartOfFragment = sel.paragraphs[0].characters.firstItem().index;
var myEndOfFragment = sel.paragraphs[sel.paragraphs.length - 1].characters.lastItem().index;
sel.parent.characters.itemByRange(myStartOfFragment,myEndOfFragment).select();
sel = app.selection[0];
var story = sel.parentStory;
var storyLength = story.length;
var selLength = sel.length;
var text = "";
var foreighChars = 0; // счётчик знаков чужого текста
var enterNum = 0; // абзацы

app.findGrepPreferences = NothingEnum.nothing;
app.changeGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences.fillColor = specColor;
app.findGrepPreferences.findWhat = ".+";
var rez = sel.findGrep();
var rezLength = rez.length;
if (rezLength == 0) {
    alert("Отмеченный цветом '" + specColor + "' текст не найден.",programTitul);
    exit();
    }
pBar = new ProgressBar(programTitul); 
pBar.reset("", rezLength);
for (var i = 0; i < rezLength; i++, pBar.hit()) { // i++
    foreighChars = foreighChars + rez[i].length;
    } // i++
pBar.close();
enterNum = sel.paragraphs.length;
var wordsLength = sel.words.length;
rusChars = selLength - foreighChars;
text = "Количество букв, окрашенных чёрным цветом: " + rusChars + "\rКоличество букв цвета '" + specColor + "': " + foreighChars + "\rОбщее число слов: " + wordsLength + "\rОбщее число абзацев: " + enterNum + "\rЧисло авторских листов с русским текстом: " + ((Number(rusChars) + Number(wordsLength) + Number(enterNum))/russianAS).toFixed(1) + "\rЧисло авторских листов с иностранным текстом: " + (foreighChars/foreignAS).toFixed(1) + "\r";
var myScriptFile = myGetScriptPath();
var rezFileName  = docName; // это txt-файл с расчётами
var myScriptFolder = decodeURI(myScriptFile.path);
var myFilePath = decodeURI(myScriptFolder + "/Info/" + rezFileName); 
var rezFile = new File (myFilePath);
rezFile.open("w");
rezFile.writeln(docName + "\r-------\r" + text);
rezFile.close();
alert(text + "\rИнформация сохранена в текстовом файле\r" + docName + "\rв папке 'Info'.\rОна в той же папке, где скрипт.", programTitul);
//rezFile.execute();
exit();
//////////////////
function myGetScriptPath() {
try { return app.activeScript; }
catch(e) { return File(e.fileName); }
}


