﻿// GetBookInfo.jsx
//
// Информация о числе абзацев и знаков во всех статьях файлов Книги.
// Если какую-то статью надо исключить из рассмотрения,
// то надо создать слой с именем '#' (имя слоя -- один символ #)
// и переместить на этот слой хотя бы один фрейм этой статьи.
// Информация о результате будет в txt-файле, название которого начинаетс с  'Book#' (переменная infoBookNamePrefix), а потом идёт название файла Книги и расширение '.txt'.
// Например, после обработки файла 'MagazinesDigest.indb' результат обработки будет помещён в файл 'Book#MagazinesDigest.txt'.
// Этот файл в папке 'Info', она в той же папке, где скрипт.
//
// В версии индизайна 2020 разработчики отключили опцию checked в оформлении списка типа listbox.
// И этот скрипт именно для этой версии индизайна, для других релизов есть своя программа.
//
// Подсчёт площади рисунков -- работает во всём доументе, отключения из подсчёта страниц или статей нет.
//
// © Михаил Иванюшин  |  https://dotextok.ru   |   2017-2022  |   dotextok@gmail.com
//
#targetengine "inbdBookInfoB"
var specialLayerName = "#";
var infoBookNamePrefix = "Book#";
var programTitul = "Статистика книги (indb-файл) • 10.03.2022";
var numberOfCharacters = 0;
var numberOfPara = 0;
var charsInTables = 0;
var charsInFootnotes = 0;
var charsInEndnotes = 0;

var allStories = 0;
var procStories = 0;
var missedStories = 0;
var procTablesInTheStories = 0;
////
////
var mySpaceOfPictures = 0; // площадь рисунков в документе, кв. см
var myFrName; // имя текущего фрейма документа
var myCurrPictFrame; // ссылка на текущий нетекстовый фрейм
var myCurrGroup; // ссылка на текущую группу
var myCurrGraph; // ссылка на текущий рисунок
var myCurrPictName; // имя этого рисунка
var myNamesOfAllPictures = new Array;
var myPictureWidth;
var myPictureHeight;
var myNumberOfPictures = 0;
var myObjParent;
////
var dropListWidth = 150; // ширина меню стилей и шаблонов

var ProgressBar = function(title) { // ProgressBar
     var w = new Window('palette', title, {x:0, y:0, width:700, height:52},{closeButton: true}),       
          pbb = w.add('progressbar', {x:20, y:12, width:660, height:12});
          pbd = w.add('progressbar', {x:20, y:32, width:660, height:12});          
          w.center();
     this.breset = function(maxValue) {
          pbb.value = 0;
          pbb.maxvalue = maxValue;
          w.show();
          w.update();
        }; 
     this.dreset = function(maxValue) {
          pbd.value = 0;
          pbd.maxvalue = maxValue;
          w.show();
          w.update();
        };   
     this.bhit = function() {pbb.value += 1; w.update();};     
     this.dhit = function() {pbd.value += 1; w.update();};     
     this.close = function() {w.close();};
} // ProgressBar
////
var parseIntAppVersion = parseInt (app.version);
if (parseIntAppVersion != 15) {
    alert("Этот вариант скрипта только для версии InDesign CC2020. Для остальных есть другой скрипт.", programTitul);
    exit();
    }
if (app.books.length != 1) {
    alert("Этот скрипт подсчитывает объём файлов, собранных в \"книгу\" — файл с расширением 'indb'. Должна быть открыта только одна книга, но не должно быть ни одного открытого indd-файла.\nДля подсчёта объема одного файла есть другой скрипт.",programTitul);   
    exit();
    }
if(app.books.item(0).bookContents.length == 0) { // bookContents.length == 0
    alert ("В книге нет файлов.",programTitul);
    exit();
    } // bookContents.length == 0

if (app.documents.length > 0) { // d.l > 0
    alert ("Должна быть открыта только одна книга, но не должно быть ни одного открытого indd-файла.",programTitul);
    exit();    
    }  // d.l > 0
//~ var noName = false;
//~ try { var myDocPath = app.documents[0].filePath; } // если документ не сохранён, маршрут не сообщается
//~ catch(e) {
//~    alert("Это только что созданный и ещё ни разу не сохранённый файл.\nДайте ему имя.",programTitul);   
//~    noName = true;
//~     }
//~ if (noName) {
//~     try { app.documents[0].save(); }
//~     catch (e) {
//~          alert("Файл не был сохранён с новым именем.",programTitul);
//~         exit(); 
//~         }
//~     }
var currentDoc = decodeURI(app.books[0].bookContents.item(0).fullName);
var curD = app.open(app.books[0].bookContents.item(0).fullName);
var myLayers = app.documents[0].layers.everyItem().getElements();
var docName = infoBookNamePrefix + decodeURI(app.books[0].name).split(".indb")[0] + ".txt";
/////////////////
var myWin = myScriptWindow();
if (myWin.show() == 2) { //  == 2
    exit(); // ==2  -- это щелчок на красном крестике в правом верхнем угле окна
    }  // == 2
myWin.show();
exit();
////
function myScriptWindow() { // myScriptWindow
var win = new Window ("palette", programTitul);
buttonSize = [0,0,30,30];
win.orientation = "column";
win.alignChildren = ["fill","fill"];
var texts = win.add("group");
texts.orientation = "row";
var procSt = texts.add("checkbox", undefined, "Статьи");
procSt.value = true;
var procFt = texts.add("checkbox", undefined, "Обычные сноски");
procFt.value = false;
var procEfn = texts.add("checkbox", undefined, "Концевые сноски");
procEfn.value = false;
if (parseIntAppVersion < 15) { procEfn.enabled = false; }
var procTb = texts.add("checkbox", undefined, "Таблицы");
var space = win.add("checkbox", undefined, "Подсчет площади рисунков");
space.value = false;
///
procSt.onClick = function () { // procSt.onClick
if (procSt.value == true) { // procSt.value
    procSt.value = true;
    runProc.enabled = true;
    testSelPara();
    } // procSt.value
else { // !procSt.value
    procSt.value = false;
    if (!procSt.value && !procFt.value && !procEfn.value && !procTb.value) runProc.enabled = false;
    } // !procSt.value
} // procSt.onClick
///
procFt.onClick = function () { // procFt.onClick
if (procFt.value == true) { // procFt.value
    procFt.value = true;
    runProc.enabled = true;
    testSelPara();    
    } // procFt.value
else { // !procFt.value
    procFt.value = false;
    if (!procSt.value && !procFt.value && !procEfn.value && !procTb.value) runProc.enabled = false;
    } // !procFt.value
} // procFt.onClick
///
procEfn.onClick = function () { // procEfn.onClick
if (procEfn.value == true) { // procEfn.value
    procEfn.value = true;
    runProc.enabled = true;
    testSelPara();    
    } // procEfn.value
else { // !procEfn.value
    procEfn.value = false;
    if (!procSt.value && !procFt.value && !procEfn.value && !procTb.value) runProc.enabled = false;
    } // !procEfn.value
} // procEfn.onClick
///
procTb.onClick = function () { // procTb.onClick
if (procTb.value == true) { // procTb.value
    procTb.value = true;
    runProc.enabled = true;
    testSelPara();    
    } // procTb.value
else { // !procTb.value
    procTb.value = false;
    if (!procSt.value && !procFt.value && !procEfn.value && !procTb.value) runProc.enabled = false;
    } // !procTb.value
} // procTb.onClick
var layerLine = win.add("group");
layerLine.orientation = "row";
var layer = layerLine.add("checkbox", undefined, "Слой исключения статей из обработки");
layer.value = false;
var myLayers = app.documents[0].layers.everyItem().getElements();
if (myLayers.length == 1) layer.enabled = false; // если один слой, выбирать не из чего.
var layerList = [];
for (i = 0; i < myLayers.length; i++) layerList.push(myLayers[i].name);
var layerName = layerLine.add ("dropdownlist", undefined, layerList);
layerName.selection = 0;
layerName.minimumSize.width = layerName.maximumSize.width = dropListWidth;
layerName.enabled = false;
layer.onClick = function() { // layer.onClicik
if (layer.value == true) { 
    layer.value = true; layerName.enabled = true; 
    }
else { 
    layer.value = false; layerName.enabled = false; 
    }
} // layer.onClicik
///
var pStyles = win.add("group");
pStyles.orientation = "row";
var twoChBx =pStyles.add("group");
twoChBx.orientation = "column"
var para = twoChBx.add("checkbox", undefined, "Учесть только эти стили абзаца");
para.value = false;
var inverse = twoChBx.add("checkbox", undefined, "Инвертировать выборку стилей");
inverse.value = false;
inverse.enabled = false;
var paraStyleNames = [];    
var myParagraphStyles = app.activeDocument.allParagraphStyles;
var myParagraphStyleName, obj;
for (var i = 0; i < myParagraphStyles.length ; i++) {
    myParagraphStyleName = myParagraphStyles[i].name;
    obj = myParagraphStyles[i];
    while (obj.parent instanceof ParagraphStyleGroup) {
        myParagraphStyleName = obj.parent.name + ":" + myParagraphStyleName;
        obj = obj.parent;        
        }
    paraStyleNames.push({name:myParagraphStyleName, active: true}); //   <<<<   active: true
    } // for
var win10cs6 = pStyles.add("group"); // ScriptUI for Dummies. Listbox, p.23: In InDesign CS6 on Windows 10 you have to place the listbox in a group or a panel...
var selList = win10cs6.add("listbox", undefined, {multiselect: true});
selList.preferredSize = [190,100];
for (i = 0; i < paraStyleNames.length; i++) { // i++
    var iname = paraStyleNames[i].name;
    iname = paraStyleNames[i].active ? '\u2611 ' + iname : '\u274E ' + iname; 
    var item = selList.add('item', iname);
    item.checked = paraStyleNames[i].active;      
    } // i++
///
selList.onDoubleClick = function () { // selList.onDoubleClick     
// для выборки строки списка используется двойной клик      
if (this.selection) { // this.
    var item = this.selection;
    var itemChecked = true;
    if (item.text.match("\u2611") == null) itemChecked = false;   
    item.checked = !itemChecked;          
    var iname = item.text.replace(/^[\u2611|\u274E]/gim, '');         
    iname = item.checked ? '\u2611' + iname : '\u274E' + iname;               
    item.text = iname;     
    paraStyleNames[item.index].active = item.checked;    
} // this.
selList.selection = null; // снимем выборку после установки/снятия флажка
testSelPara();
} // selList.onDoubleClick
///
selList.enabled = false;
///
function testSelPara() { // testSelPara
var flag = 0;  
// проверка -- выбран этот стиль или нет -- выполняется проверкой символа ☑ перед названием стиля
for (i = 0; i < paraStyleNames.length; i++) { if ((String(selList.items[i])).match("\u2611") == "\u2611") flag++; }
if (flag == 0) runProc.enabled = false; else runProc.enabled = true;
} // testSelPara
///
para.onClick = function() { // para.onClicik
if (para.value == true) { 
    para.value = true; 
    inverse.enabled = true;
    selList.enabled = true; 
   for (i = 0; i < paraStyleNames.length; i++) { // 
        var iname = paraStyleNames[i].name;
        iname = '\u274E ' + iname; 
        selList.items[i].text = "";
        selList.items[i].text = iname;   
        selList.items[i].checked = false;         
       } // 
    runProc.enabled = false;
    }
else { 
    para.value = false; 
    selList.enabled = false; 
    inverse.enabled = false;
    for (i = 0; i < paraStyleNames.length; i++) { ///
        var iname = paraStyleNames[i].name;
        iname = '\u2611 ' + iname; 
        selList.items[i].text = "";        
        selList.items[i].text = iname; 
        selList.items[i].checked = true;            
        } ///
    if (!procSt.value && !procFt.value && !procEfn.value && !procTb.value) runProc.enabled = false else runProc.enabled = true;
    }
} // para.onClicik
///
inverse.onClick = function () { // inverse.onClick  
inverse.value = false;
for (i = 0; i < paraStyleNames.length; i++) {
    var item = selList.items[i];  // item --- это текущая строка списка listbox
    var itemChecked = true; // предполагаем, что сейчас перед названием стиля флажок ☑ 
    if ( item.text.match("\u2611") == null) itemChecked = false; 
    itemChecked = !itemChecked;  // инвертируем текущее состояние флажка, т.к. оно должно быть противоположным 
    if (itemChecked) var iname =  '\u2611 ' + paraStyleNames[i].name; else  var iname =  '\u274E ' + paraStyleNames[i].name; // формируем новые данные для выбранной строки listbox
       item.text = iname; // обновляем выбранную строку listbox
       selList.items[i].checked = itemChecked; // сохраняем значение checked.    
        // Хотя при этом решении --- проверять , какой символ перед названием стиля "\u2611" или "\u274E" --- этот флажок уже и не нужен.
        selList.selection = null;        
    }
testSelPara();
} // inverse.onClick
///
horizontal_line = win.add ("panel"); 
horizontal_line.minimumSize.height = horizontal_line.maximumSize.height = 1;
var theButtons = win.add("group");
theButtons.orientation = "row";
theButtons.alignChildren = ["fill", "top"];
///
myButtonSize = [0,0,175,28];
var runProc = theButtons.add("button", myButtonSize, "Узнать объём издания");
var myInfo = theButtons.add("button", [0,0,28,28], "?");
///
var stopProc = theButtons.add("button", myButtonSize, "В другой раз");
stopProc.onClick = function () { // stopProc.onClick
win.close();
exit();
} // stopProc.onClick
///
myInfo.onClick = function () { 
    Info = "> Подсчёт объема текста книги <\n   Что обрабатывать — статьи, таблицы, сноски — определяется флажками. Статьи на мастер-страницах, и на рабочем столе исключаются из обработки. Статья считается размещенной на столе, если её первый фрейм лежит на столе. \n   Можно учитывать только тексты, набранные конкретными абзацными стилями, но эти стили надо заранее оговорить. Для этого предусмотрено выпадающее меню «Учесть только эти стили абзаца». Для таблиц и сносок эта опция не работает: при наличии сносок/таблиц в статье и установленных флажках обработки, их объем будет учтён независимо от того, какие стили выбраны.\n   Если какую-то статью надо полностью исключить из рассмотрения, то достаточно сделать в работе служебный слой и переместить на этот слой любой из фреймов этой статьи. Этот слой надо выбрать в выпадающем меню «Слой исключения статей из обработки». При обработке статей, прежде чем получать информацию об объёме, просматриваются все текстовые фреймы текущей статьи, не лежит ли хоть один из них на этом слое. Если лежит, то ни эта статья, ни таблицы и сноски в ней не учитываются. \n   Программа обходит статьи, сноски, таблицы, собирая данные, сколько знаков и абзацев в каждой. Знак — это буква, пробел, перевод строки, т.е. это фактически синоним нажатия на одну из клавиш клавиатуры. Для статьей в объем попадают таблицы и сноски, но по таблицам и сноскам информация также даётся отдельными строками. При обработке сносок и таблиц число абзацев не учитывается, подсчитываются только знаки.\n   Число авторских листов — объем издания, поделённый на 40 000, результат округлен до первого знака после запятой.\n\n> Подсчет площади рисунков <\nОбрабатываются фреймы с рисунками и привязанные к тексту иллюстрации. Рисунки с одинаковыми именами учитываются один раз за исключением тех, что вставлены через буфер. Эти объекты не появляются в папке Links и учитываются всякий раз при появлении их в вёрстке.\n   Число авторских листов иллюстративного материала — площадь рисунков [кв. см], поделённая на 3000, результат округлен до первого знака после запятой.\n\n   Пользователь должен удалить все неиспользуемые объекты с монтажного стола, т.к. не задействовано определение, где размещен рисунок — на полосе или за её пределами.\nПрограмма также не учитывает возможное наличие атрибута «Nonprinting» у некоторых фреймов или групп.\n\n———————\n   © Михаил Иванюшин, 2017-2022\n   adobeindesign.ru  |  dotextok.ru\n   m.ivanyushin@gmail.com\n";
    alert(Info, programTitul); 
    }
///
runProc.onClick = function () { // runProc.onClick
var pBar = new ProgressBar("Подсчёт объёма текста в книге"); 
var bookL = app.books[0].bookContents.length;
var theBook = app.books[0];
pBar.breset(bookL);
procDoc (pBar);
app.activeDocument.close(SaveOptions.NO);
pBar.bhit();
for (b = 1; b < bookL; b++, pBar.bhit()) { // b++
    var currentDoc = decodeURI(theBook.bookContents.item(b).fullName);
    var curD = app.open(theBook.bookContents.item(b).fullName);
    procDoc (pBar);
    curD.close(SaveOptions.NO);
    } // b++
pBar.close();
win.close();
var spaceAS = (mySpaceOfPictures/3000).toFixed(1);
var spaceArea = "\nПлощадь рисунков " + mySpaceOfPictures.toFixed(2)  + " кв.см.\nЧисло рисунков " + myNumberOfPictures+".\nЧисло авторских (учётно-издательских) листов " + spaceAS + ".\n";
var AboutFt = "";
var AboutTbl = "";
var avtL = 0;
if (charsInFootnotes > 0) AboutFt = "\nЧисло знаков в сносках: " + charsInFootnotes + ".";
if (charsInTables > 0) AboutTbl = "\nЧисло знаков в таблицах: " + charsInTables + ", общее число таблиц: " + procTablesInTheStories + ".";
var valueAvtl = (numberOfCharacters/40000).toFixed(1);
if (numberOfCharacters > 0) avtL = "\nЧисло авторских (учётно-издательских) листов " + valueAvtl + ".";
if (missedStories > 0) var text = "Количество обработанных статей: " + procStories + ".\nИсключено из обработки: " + missedStories + ".\nЧисло абзацев: " + numberOfPara + "\nЧисло знаков, включая пробелы и переводы строки: " + numberOfCharacters + "."+ AboutFt + AboutTbl + ".";  
else var text = "Количество обработанных статей: " + procStories + ".\nЧисло абзацев: " + numberOfPara + ".\nЧисло знаков, включая пробелы и переводы строки: " + numberOfCharacters + "." + AboutFt + AboutTbl;  
text = text + "\nЧисло знаков в сносках и таблицах учтено в общем числе знаков.";
text= text +  "\n" + avtL;
if (space.value) text = text + "\n" + spaceArea;
var avtlSum =  Number(valueAvtl) + Number(spaceAS);
if (numberOfCharacters > 0 && mySpaceOfPictures > 0) text= text + "\nОбщее число авторских (учётно-издательских) листов: " + avtlSum+ ".";
var myScriptFile = myGetScriptPath();
var rezFileName  = docName; // это txt-файл с расчётами
var myScriptFolder = decodeURI(myScriptFile.path);
var myFilePath = decodeURI(myScriptFolder + "/Info/" + rezFileName);  
var rezFile = new File (myFilePath);
rezFile.open("w");
rezFile.writeln(docName + "\r-------\r" + text);
rezFile.close();
alert (text + "\r\rИнформация сохранена в текстовом файле\r" + docName + "\rв папке 'Info'.\rОна в той же папке, где скрипт.", programTitul);
//rezFile.execute();
} // runProc.onClick  
///
function procDoc (pBar) { // procDoc ()
if (para.value) { // para.value
   var pArray = {};
   for (i = 0; i < paraStyleNames.length; i++) { // i++
      if ((String(selList.items[i])).match("\u2611") == "\u2611") { // if      
           pArray[paraStyleNames[i].name] = paraStyleNames[i].name;
           } // if
       } // i++
    } // para.value
if (layer.value) specialLayer = layerName.selection else specialLayer = "";
var myDoc = app.activeDocument;
allStories = myDoc.stories.length;
pBar.dreset(allStories);
for (s = 0; s < myDoc.stories.length; s++, pBar.dhit()) { // s++
    var st = myDoc.stories[s];
    if (st.length == 0) continue;
    if (st.characters[0].parentTextFrames[0].constructor.name == "EndnoteTextFrame") continue;    
    missThisStory = false;
    var txtContsLength = st.textContainers.length;
    for (c = 0; c < txtContsLength; c++) { // c++
        if (st.textContainers[0].parent.constructor.name == "MasterSpread" || st.textContainers[0].parentPage == null) {
            missThisStory = true;     
            break;
            }
        var usedLayer = st.textContainers[c].itemLayer.name;
        if (usedLayer == specialLayer) { // == specialLayer
            missedStories++;
            missThisStory = true;
            break;
            } // == specialLayer
        } // c++
    if (missThisStory) continue;
    if (procSt.value) { // procSt.value
        if (!para.value) { // !para.value
            numberOfCharacters += st.characters.length;
            numberOfPara += st.paragraphs.length;
            } // !para.value
        else { // para.value
            var prg = st.paragraphs.everyItem().getElements();
            var prgN = prg.length;
            for (p =0; p < prgN; p++) { // p++
                var pName = prg[p].appliedParagraphStyle.name;
                if (pArray[pName] != undefined) {
                    numberOfCharacters += prg[p].characters.length;
                    numberOfPara += prg[p].paragraphs.length;
                    }
                } // p++
            } //para.value
    procStories++;
    } // procSt.value
    if (procTb.value) { // procTb.value
    var howManyTables = st.tables.length;
        if (howManyTables > 0) { // st.tables.length > 0
            procTablesInTheStories += howManyTables;            
            for (t = 0; t < howManyTables; t++) { // t++
                var table = st.tables[t];
                var cellsN = table.cells.length;
                for (cl = 0; cl < cellsN; cl++) { // cl++
                    var cellText = table.cells[cl].texts[0];
                    try { if (cellText.length == 0) continue } catch (e) { continue }
                    numberOfCharacters += cellText.characters.length;
                    charsInTables += cellText.characters.length;
                    } // cl++
                } // t++
            } // st.tables.length > 0
        }// procTb.value
    if (procFt.value) { // procFt.value
        var footnotesNumber = st.footnotes.length;
            if (footnotesNumber > 0) { // footnotesNumber > 0
            for (f = 0; f < footnotesNumber; f++) { // f++
                fN = st.footnotes[f];
                try { if (fN.texts[0].length == 0) continue } catch (e) { continue }
                numberOfCharacters += fN.characters.length;      
                charsInFootnotes += fN.characters.length;
                } // f++
            } // footnotesNumber > 0
        } // procFt.value
    if (procEfn.value) { // procEfn.value
        var endnotesNumber = st.endnotes.length;
            if (endnotesNumber > 0) { // endnotesNumber > 0
            for (f = 0; f < endnotesNumber; f++) { // f++
                fN = st.endnotes[f];
                try { if (fN.texts[0].length == 0) continue } catch (e) { continue }
                numberOfCharacters += fN.characters.length;      
                charsInEndnotes += fN.characters.length;
                } // f++
            } // endnotesNumber > 0
        } // procEfn.value 
    } // s++
pArray = null;
//// теперь картинки этого файла
if (space.value && myDoc.allPageItems.length > 0) { // space.value
var allPageItemsLength = myDoc.allPageItems.length;  
myUnitIsCentimeters = 2053336435;
var myCurrentHorUnits = myDoc.viewPreferences.horizontalMeasurementUnits;
var myCurrentVertUnits = myDoc.viewPreferences.verticalMeasurementUnits;
myDoc.viewPreferences.horizontalMeasurementUnits = myUnitIsCentimeters;
myDoc.viewPreferences.verticalMeasurementUnits = myUnitIsCentimeters;
for (i = 0; i < allPageItemsLength; i++/*, pBar.hit()*/) { // 
	var myFrName = myDoc.allPageItems[i].constructor.name;
	if (myFrName == 'Group') { // Group
		// В массив allPageItems[ ] входят как отдельные фреймы, так и их группы.
		// Поскольку в этом цикле будет обращение к каждому элементу, группы пропускаем.
		continue;
		} // Group
	if (((myFrName == 'Rectangle' || myFrName == 'Oval' || myFrName == 'Polygon')) && (myDoc.allPageItems[i].allGraphics.length != 0))  { // PictFrame with Image
		myCurrPictFrame = myDoc.allPageItems[i];
		myObjParent = myCurrPictFrame.parent;
		mySpaceCalculation();
		continue;
	} // PictFrame with Image
} // for-i
myDoc.viewPreferences.horizontalMeasurementUnits = myCurrentHorUnits;
myDoc.viewPreferences.verticalMeasurementUnits = myCurrentVertUnits;
} // space.value
} // procDoc ()
///
return win;
} // myScriptWindow
//////////
function myGetScriptPath() {
try { return app.activeScript; }
catch(e) { return File(e.fileName); }
}
/////
function mySpaceCalculation() {
try { myCurrPictName = myCurrPictFrame.allGraphics[0].itemLink.name; } // в ряде случаев при вставке объектов через буфер они не появляются в панели Links. 
catch (e) { myCurrPictName = null; } 	// поэтому будут учтены без контроля их повторного появления.	
if ( myLookingForCurrPictNameInArray(myCurrPictName) ==true ) return; // если иллюстрация с этим именем уже встречалась, она больше не учитывается	
myPictureWidth= myCurrPictFrame.geometricBounds[3] - myCurrPictFrame.geometricBounds[1];
myPictureHeight= myCurrPictFrame.geometricBounds[2] - myCurrPictFrame.geometricBounds[0];
mySpaceOfPictures += myPictureWidth*myPictureHeight;
myNumberOfPictures++;
return;
}
/////
function myLookingForCurrPictNameInArray(myCurrPictName) {
var myP = 0;
if (myCurrPictName == null) return(false); // если рисунок вставлен через буфер, и его нет в панели Links, он учитывается столько раз, сколько было таких вставок
for (j =0; j < myNamesOfAllPictures.length; j++) { //
	if (myNamesOfAllPictures[j] == myCurrPictName) { myP = 1; break; }
	}
if (myP == 1) return (true);
myNamesOfAllPictures.push(myCurrPictName);
return(false);
}
