﻿// GetFileInfo.jsx
//
// Информация о числе абзацев и знаков во всех статьях открытого файла.
// Если какую-то статью надо исключить из рассмотрения,
// то надо создать слой с именем '#' (имя слоя -- один символ #)
// и переместить на этот слой хотя бы один фрейм этой статьи.
// Информация о результате будет в txt-файле, название которого начинаетс с  'File#' (переменная infoFileNamePrefix), а потом идёт название обрабатываемого файла и расширение '.txt'.
// Например, после обработки файла 'AviationNews.indd' результат обработки будет помещён в файл 'File#AviationNews.txt'.
// Этот файл в папке 'Info', она в той же папке, где скрипт.
//
// В версии индизайна 2020 разработчики отключили опцию checked в оформлении списка типа listbox.
// Поэтому для этой версии есть своя программа.
//
// Подсчёт площади рисунков -- работает во всём доументе, отключения из подсчёта страниц или статей нет.
//
// © Михаил Иванюшин  |  https://dotextok.ru   |   2021-2022  |   dotextok@gmail.com
//
#targetengine "BookInfoN"
var specialLayerName = "#";
var infoFileNamePrefix = "File#";
var programTitul = "Статистика издания • 10.03.2022";
var numberOfCharacters = 0;
var numberOfPara = 0;
var charsInTables = 0;
var charsInFootnotes = 0;
var charsInEndnotes = 0;
var allStories = 0;
var procStories = 0;
var missedStories = 0;
////
var mySpaceOfPictures = 0; // площадь рисунков в документе, кв. см
var myFrName; // имя текущего фрейма документа
var myCurrPictFrame; // ссылка на текущий нетекстовый фрейм
var myCurrGroup; // ссылка на текущую группу
var myCurrGraph; // ссылка на текущий рисунок
var myCurrPictName; // имя этого рисунка
var myNamesOfAllPictures = new Array;
var myPictureWidth;
var myPictureHeight;
var myNumberOfPictures = 0;
var myObjParent;
////
var parseIntAppVersion = parseInt (app.version);
if (parseIntAppVersion == 15) {
    alert("Этот вариант скрипта не работает в версии InDesign CC2020. Есть другой скрипт — для CS6 – CC2019, CC2021+.", programTitul);
    exit();
    }
var dropListWidth = 150; // ширина меню стилей и шаблонов
///

var ProgressBar = function(title) { // ProgressBar
     var w = new Window('palette', title, {x:0, y:0, width:700, height:42},{closeButton: true}),       
          pb = w.add('progressbar', {x:20, y:12, width:660, height:12});
          w.center();
     this.reset = function(maxValue) {
          pb.value = 0;
          pb.maxvalue = maxValue;
          w.show();
          w.update();
      }; 
     this.hit = function() {pb.value += 1; w.update();};
     this.close = function() {w.close();};
} // ProgressBar
////
if (app.documents.length == 0) {
    alert("Нет открытых документов.",programTitul);   
    exit();
    }
var noName = false;
try { var myDocPath = app.documents[0].filePath; } // если документ не сохранён, маршрут не сообщается
catch(e) {
   alert("Это только что созданный и ещё ни разу не сохранённый файл.\nДайте ему имя.",programTitul);   
   noName = true;
    }
if (noName) {
    try { app.documents[0].save(); }
    catch (e) {
         alert("Файл не был сохранён с новым именем.",programTitul);
        exit(); 
        }
    }
var myDoc = app.activeDocument;
//~ if (myDoc.stories.length < 2) {
//~     alert("Статистику этого документа можно узнать из панели 'Информация'.",programTitul);   
//~     exit();    
//~     }
var allStories = 0;
var allTables = 0;
for (s = 0; s < myDoc.stories.length; s++) { // s++
    var st = myDoc.stories[s];
    allStories += st;
    if (st.textContainers[0].parent.constructor.name == "MasterSpread" || st.textContainers[0].parentPage == null) continue;    
    if (st.overflows) { // st.overlows
        alert("В одной из статей есть вытесненный текст. Обработка отменена.");
        exit();
        } // st.overlows
    var howManyTables = st.tables.length;
    allTables += howManyTables;
    if (howManyTables > 0) { // st.tables.length > 0
            for (t = 0; t < howManyTables; t++) { // t++
                var table = st.tables[t];
                var cellsN = table.cells.length;
                for (cl = 0; cl < cellsN; cl++) { // cl++
                    var cellText = table.cells[cl].texts[0];
                    try { if (cellText.length == 0) continue } catch (e) { continue }
                    if (table.cells[cl].overflows) { // overlows
                        alert("В какой-то таблице в одной из ячеек есть вытесненный текст. Обработка отменена.");
                        exit();
                        } // overlows
                    } // cl++
                } // t++
            } // st.tables.length > 0        
// в сносках переполнения быть не может.   
        } // s++
var myLayers = app.documents[0].layers.everyItem().getElements();
var docName = infoFileNamePrefix + decodeURI(myDoc.name).split(".indd")[0] + ".txt";
/////////
var myWin = myScriptWindow();
if (myWin.show() == 2) { //  == 2
    exit(); // ==2  -- это щелчок на красном крестике в правом верхнем угле окна
    }  // == 2
myWin.show();
exit();
////
function myScriptWindow() { // myScriptWindow
var win = new Window ("palette", programTitul);
buttonSize = [0,0,30,30];
win.orientation = "column";
win.alignChildren = ["fill","fill"];
var texts = win.add("group");
texts.orientation = "row";
var procSt = texts.add("checkbox", undefined, "Статьи");
procSt.value = true;
var procFt = texts.add("checkbox", undefined, "Обычные сноски");
procFt.value = false;
var procEfn = texts.add("checkbox", undefined, "Концевые сноски");
procEfn.value = false;
if (parseIntAppVersion < 15) { procEfn.enabled = false; }
var procTb = texts.add("checkbox", undefined, "Таблицы");
var space = win.add("checkbox", undefined, "Подсчет площади рисунков");
space.value = false;
///
procSt.onClick = function () { // procSt.onClick
if (procSt.value == true) { // procSt.value
    procSt.value = true;
    runProc.enabled = true;
    testSelPara();
    } // procSt.value
else { // !procSt.value
    procSt.value = false;
    if (!procSt.value && !procFt.value && !procEfn.value && !procTb.value) runProc.enabled = false;
    } // !procSt.value
} // procSt.onClick
///
procFt.onClick = function () { // procFt.onClick
if (procFt.value == true) { // procFt.value
    procFt.value = true;
    runProc.enabled = true;
    testSelPara();    
    } // procFt.value
else { // !procFt.value
    procFt.value = false;
    if (!procSt.value && !procFt.value && !procEfn.value && !procTb.value) runProc.enabled = false;
    } // !procFt.value
} // procFt.onClick
///
procEfn.onClick = function () { // procEfn.onClick
if (procEfn.value == true) { // procEfn.value
    procEfn.value = true;
    runProc.enabled = true;
    testSelPara();    
    } // procEfn.value
else { // !procEfn.value
    procEfn.value = false;
    if (!procSt.value && !procFt.value && !procEfn.value && !procTb.value) runProc.enabled = false;
    } // !procEfn.value
} // procEfn.onClick
///
procTb.onClick = function () { // procTb.onClick
if (procTb.value == true) { // procTb.value
    procTb.value = true;
    runProc.enabled = true;
    testSelPara();    
    } // procTb.value
else { // !procTb.value
    procTb.value = false;
    if (!procSt.value && !procFt.value && !procEfn.value && !procTb.value) runProc.enabled = false;
    } // !procTb.value
} // procTb.onClick
var layerLine = win.add("group");
layerLine.orientation = "row";
layerLine.alignChildren = ["left","bottom"];
var layer = layerLine.add("checkbox", undefined, "Слой исключения статей из обработки");
layer.value = false;
var myLayers = app.documents[0].layers.everyItem().getElements();
if (myLayers.length == 1) layer.enabled = false; // если один слой, выбирать не из чего.
var layerList = [];
for (i = 0; i < myLayers.length; i++) layerList.push(myLayers[i].name);
var layerName = layerLine.add ("dropdownlist", undefined, layerList);
layerName.selection = 0;
layerName.minimumSize.width = layerName.maximumSize.width = dropListWidth;
layerName.enabled = false;
layer.onClick = function() { // layer.onClicik
if (layer.value == true) { 
    layer.value = true; layerName.enabled = true; 
    }
else { 
    layer.value = false; layerName.enabled = false; 
    }
} // layer.onClicik
///
var pStyles = win.add("group");
pStyles.orientation = "row";
var twoChBx =pStyles.add("group");
twoChBx.orientation = "column";
var para = twoChBx.add("checkbox", undefined, "Учесть только эти стили абзаца");
para.value = false;
var inverse = twoChBx.add("checkbox", undefined, "Инвертировать выборку стилей");
inverse.value = false;
inverse.enabled = false;
var paraStyleNames = [];    
var myParagraphStyles = app.activeDocument.allParagraphStyles;
var myParagraphStyleName, obj;
for (var i = 0; i < myParagraphStyles.length ; i++) {
    myParagraphStyleName = myParagraphStyles[i].name;
    obj = myParagraphStyles[i];
    while (obj.parent instanceof ParagraphStyleGroup) {
        myParagraphStyleName = obj.parent.name + ":" + myParagraphStyleName;
        obj = obj.parent;        
        }
    paraStyleNames.push(myParagraphStyleName);
    } // for
var win10cs6 = pStyles.add("group"); // ScriptUI for Dummies. Listbox, p.23: In InDesign CS6 on Windows 10 you have to place the listbox in a group or a panel...
var selList = win10cs6.add("listbox", undefined, paraStyleNames, {multiselect: true});
selList.preferredSize = [190,100];
for (i = 0; i < paraStyleNames.length; i++) selList.items[i].checked = true; // чтобы появилось пустое поле перед названием абз. стиля
selList.onChange = function() { // selList.onClick
// по каждому выбору ставим флажок. Или снимаем его.
if (selList.selection == null) { return;} // после установки/снятия флажка система реагирует на это действие. Но состояние null не может обрабатываться процедурой .onChange, поэтому надо этот момент учитывать
if (selList.items[selList.selection[0].index].checked) {
    selList.items[selList.selection[0].index].checked = false;
    testSelPara();
    }
else {
    selList.items[selList.selection[0].index].checked = true;
    if (!procSt.value && !procFt.value && !procEfn.value && !procTb.value) runProc.enabled = false else runProc.enabled = true;    
    }
selList.selection = null; // снимем выборку после установки/снятия флажка
} //selList.onClick
selList.enabled = false;
///
function testSelPara() { // testSelPara
flag = 0;
for (i = 0; i < paraStyleNames.length; i++) if (selList.items[i].checked) flag++;    
if (flag == 0) runProc.enabled = false;
} // testSelPara
///
para.onClick = function() { // para.onClicik
if (para.value == true) { 
    para.value = true; 
    inverse.enabled = true;
    selList.enabled = true; 
    for (i = 0; i < paraStyleNames.length; i++) selList.items[i].checked = false;
    runProc.enabled = false;
    }
else { 
    para.value = false; 
    selList.enabled = false; 
    inverse.enabled = false;
    for (i = 0; i < paraStyleNames.length; i++) selList.items[i].checked = true;   
    if (!procSt.value && !procFt.value && !procEfn.value && !procTb.value) runProc.enabled = false else runProc.enabled = true;
    }
} // para.onClicik
///
inverse.onClick = function () { // inverse.onClick
var selState;    
inverse.value = false;
for (i = 0; i < paraStyleNames.length; i++) {
    selState = selList.items[i].checked;
    selList.items[i].checked = !selState;
    }
} // inverse.onClick
///
horizontal_line = win.add ("panel"); 
horizontal_line.minimumSize.height = horizontal_line.maximumSize.height = 1;
var theButtons = win.add("group");
theButtons.orientation = "row";
theButtons.alignChildren = ["fill", "top"];
///
myButtonSize = [0,0,180,28];
var runProc = theButtons.add("button", myButtonSize, "Узнать объём издания");
var myInfo = theButtons.add("button", [0,0,28,28], "?");
var stopProc = theButtons.add("button", myButtonSize, "В другой раз");
///
stopProc.onClick = function () { // stopProc.onClick
win.close();
exit();
} // stopProc.onClick
///
myInfo.onClick = function () { 
    Info = "> Подсчёт объема текста <\n   Что обрабатывать — статьи, таблицы, сноски — определяется флажками. Статьи на мастер-страницах, и на рабочем столе исключаются из обработки. Статья считается размещенной на столе, если её первый фрейм лежит на столе. \n   Можно учитывать только тексты, набранные конкретными абзацными стилями, но эти стили надо заранее оговорить. Для этого предусмотрено выпадающее меню «Учесть только эти стили абзаца». Для таблиц и сносок эта опция не работает: при наличии сносок/таблиц в статье и установленных флажках обработки, их объем будет учтён независимо от того, какие стили выбраны.\n   Если какую-то статью надо полностью исключить из рассмотрения, то достаточно сделать в работе служебный слой и переместить на этот слой любой из фреймов этой статьи. Этот слой надо выбрать в выпадающем меню «Слой исключения статей из обработки». При обработке статей, прежде чем получать информацию об объёме, просматриваются все текстовые фреймы текущей статьи, не лежит ли хоть один из них на этом слое. Если лежит, то ни эта статья, ни таблицы и сноски в ней не учитываются. \n   Программа обходит статьи, сноски, таблицы, собирая данные, сколько знаков и абзацев в каждой. Знак — это буква, пробел, перевод строки, т.е. это фактически синоним нажатия на одну из клавиш клавиатуры. Для статьей в объем попадают таблицы и сноски, но по таблицам и сноскам информация также даётся отдельными строками. При обработке сносок и таблиц число абзацев не учитывается, подсчитываются только знаки.\n   Число авторских листов — объем издания, поделённый на 40 000, результат округлен до первого знака после запятой.\n\n> Подсчет площади рисунков <\nОбрабатываются фреймы с рисунками и привязанные к тексту иллюстрации. Рисунки с одинаковыми именами учитываются один раз за исключением тех, что вставлены через буфер. Эти объекты не появляются в папке Links и учитываются всякий раз при появлении их в вёрстке.\n   Число авторских листов иллюстративного материала — площадь рисунков [кв. см], поделённая на 3000, результат округлен до первого знака после запятой.\n\n   Пользователь должен удалить все неиспользуемые объекты с монтажного стола, т.к. не задействовано определение, где размещен рисунок — на полосе или за её пределами.\nПрограмма также не учитывает возможное наличие атрибута «Nonprinting» у некоторых фреймов или групп.\n\n———————\n   © Михаил Иванюшин, 2017-2022\n   adobeindesign.ru  |  dotextok.ru\n   m.ivanyushin@gmail.com\n";
    alert(Info, programTitul); 
    }
///
runProc.onClick = function () { // runProc.onClick
if (para.value) { // para.value
   var pArray = {};
   for (i = 0; i < paraStyleNames.length; i++) { // i++
       if (selList.items[i].checked) { // if
           pArray[paraStyleNames[i]] = paraStyleNames[i];
           } // if
       } // i++
    } // para.value
if (layer.value) specialLayer = layerName.selection else specialLayer = "";
allStories = myDoc.stories.length;
var procTablesInTheStories = 0;
var pBar = new ProgressBar("Подсчёт объёма текста"); 
pBar.reset(allStories);
for (s = 0; s < allStories; s++, pBar.hit()) { // s++
    var st = myDoc.stories[s];
    try { if (st.length == 0) continue } catch (e) { continue }
    if (st.characters[0].parentTextFrames[0].constructor.name == "EndnoteTextFrame") continue;
    missThisStory = false;
    var txtContsLength = st.textContainers.length;
    for (c = 0; c < txtContsLength; c++) { // c++
        if (st.textContainers[0].parent.constructor.name == "MasterSpread" || st.textContainers[0].parentPage == null) {
            missThisStory = true;     
            break;
            }
        var usedLayer = st.textContainers[c].itemLayer.name;
        if (usedLayer == specialLayer) { // == specialLayer
            missedStories++;
            missThisStory = true;
            break;
            } // == specialLayer
        } // c++
    if (missThisStory) continue;
    if (procSt.value) { // procSt.value
        if (!para.value) { // !para.value
            numberOfCharacters += st.characters.length;
            numberOfPara += st.paragraphs.length;
            } // !para.value
        else { // para.value
            var prg = st.paragraphs.everyItem().getElements();
            var prgN = prg.length;
            for (p =0; p < prgN; p++) { // p++
                var pName = prg[p].appliedParagraphStyle.name;
                if (pArray[pName] != undefined) {
                    numberOfCharacters += prg[p].characters.length;
                    numberOfPara += prg[p].paragraphs.length;
                    }
                } // p++
            } //para.value
    procStories++;
    } // procSt.value
    if (procTb.value) { // procTb.value
    var howManyTables = st.tables.length;
        if (howManyTables > 0) { // st.tables.length > 0
            procTablesInTheStories += howManyTables;
            for (t = 0; t < howManyTables; t++) { // t++
                var table = st.tables[t];
                var cellsN = table.cells.length;
                for (cl = 0; cl < cellsN; cl++) { // cl++
                    var cellText = table.cells[cl].texts[0];
                    try { if (cellText.length == 0) continue } catch (e) { continue }
                    numberOfCharacters += cellText.characters.length;
                    charsInTables += cellText.characters.length;
                    } // cl++
                } // t++
            } // st.tables.length > 0
        }// procTb.value
    if (procFt.value) { // procFt.value
        var footnotesNumber = st.footnotes.length;
            if (footnotesNumber > 0) { // footnotesNumber > 0
            for (f = 0; f < footnotesNumber; f++) { // f++
                fN = st.footnotes[f];
                try { if (fN.texts[0].length == 0) continue } catch (e) { continue }
                numberOfCharacters += fN.characters.length;      
                charsInFootnotes += fN.characters.length;
                } // f++
            } // footnotesNumber > 0
        } // procFt.value
    if (procEfn.value) { // procEfn.value
        var endnotesNumber = st.endnotes.length;
            if (endnotesNumber > 0) { // endnotesNumber > 0
            for (f = 0; f < endnotesNumber; f++) { // f++
                fN = st.endnotes[f];
                try { if (fN.texts[0].length == 0) continue } catch (e) { continue }
                numberOfCharacters += fN.characters.length;      
                charsInEndnotes += fN.characters.length;
                } // f++
            } // endnotesNumber > 0
        } // procEfn.value    
    } // s++
pBar.close();
//// теперь картинки
var spaceArea = "";
if (space.value && myDoc.allPageItems.length > 0) { // space.value
var allPageItemsLength = myDoc.allPageItems.length;  
myUnitIsCentimeters = 2053336435;
var myCurrentHorUnits = myDoc.viewPreferences.horizontalMeasurementUnits;
var myCurrentVertUnits = myDoc.viewPreferences.verticalMeasurementUnits;
myDoc.viewPreferences.horizontalMeasurementUnits = myUnitIsCentimeters;
myDoc.viewPreferences.verticalMeasurementUnits = myUnitIsCentimeters;
var pBar = new ProgressBar("Подсчёт площади рисунков в документе"); 
pBar.reset(allPageItemsLength);
for (i = 0; i < allPageItemsLength; i++, pBar.hit()) { // 
	var myFrName = myDoc.allPageItems[i].constructor.name;
	if (myFrName == 'Group') { // Group
		// В массив allPageItems[ ] входят как отдельные фреймы, так и их группы.
		// Поскольку в этом цикле будет обращение к каждому элементу, группы пропускаем.
		continue;
		} // Group
	if (((myFrName == 'Rectangle' || myFrName == 'Oval' || myFrName == 'Polygon')) && (myDoc.allPageItems[i].allGraphics.length != 0))  { // PictFrame with Image
		myCurrPictFrame = myDoc.allPageItems[i];
		myObjParent = myCurrPictFrame.parent;
		mySpaceCalculation();
		continue;
	} // PictFrame with Image
} // for-i
var spaceAS = (mySpaceOfPictures/3000).toFixed(1);
spaceArea = "\nПлощадь рисунков " + mySpaceOfPictures.toFixed(2)  + " кв.см.\nЧисло рисунков " + myNumberOfPictures+".\nЧисло авторских (учётно-издательских) листов " + spaceAS + ".\n";
myDoc.viewPreferences.horizontalMeasurementUnits = myCurrentHorUnits;
myDoc.viewPreferences.verticalMeasurementUnits = myCurrentVertUnits;
} // space.value
win.close();
var AboutFt = "";
var AboutTbl = "";
var AboutEnFt = "";
var avtL = 0;
if (charsInFootnotes > 0) AboutFt = "\nЧисло символов в обычных сносках: " + charsInFootnotes + ".";
if (charsInEndnotes > 0) AboutEnFt= "\nЧисло знаков в концевых сносках: " + charsInEndnotes + ".";
if (charsInTables > 0) AboutTbl = "\nЧисло знаков в таблицах: " + charsInTables + ", общее число таблиц: " + procTablesInTheStories + ".";
var valueAvtl = (numberOfCharacters/40000).toFixed(1);
if (numberOfCharacters > 0) avtL = "\nЧисло авторских (учётно-издательских) листов " + valueAvtl + ".";
if (missedStories > 0) var text = "Количество обработанных статей: " + procStories + ".\nИсключено из обработки: " + missedStories + ".\nЧисло абзацев: " + numberOfPara + "\nОбщее число знаков, включая пробелы и переводы строки: " + numberOfCharacters + "."  + AboutFt + AboutEnFt + AboutTbl;  
else var text = "Количество обработанных статей: " + procStories + ".\nЧисло абзацев: " + numberOfPara + ".\nОбщее число знаков, включая пробелы и переводы строки: " + numberOfCharacters + "." + AboutFt + AboutEnFt + AboutTbl;  
text = text + "\nЧисло знаков в сносках и таблицах учтено в общем числе знаков.";
text= text +  "\n" + avtL;
if (space.value) text = text + "\n" + spaceArea;
var avtlSum =  Number(valueAvtl) + Number(spaceAS);
if (numberOfCharacters > 0 && mySpaceOfPictures > 0) text= text + "\nОбщее число авторских (учётно-издательских) листов: " + avtlSum + ".";
var myScriptFile = myGetScriptPath();
var rezFileName  = docName; // это txt-файл с расчётами
var myScriptFolder = decodeURI(myScriptFile.path);
var myFilePath = decodeURI(myScriptFolder + "/Info/" + rezFileName); 
var rezFile = new File (myFilePath);
rezFile.open("w");
rezFile.writeln(docName + "\r-------\r" + text);
rezFile.close();
alert (text + "\r\rИнформация сохранена в текстовом файле\r" + docName + "\rв папке 'Info'.\rОна в той же папке, где скрипт.", programTitul);
//rezFile.execute();
} // runProc.onClick    
///
return win; 
} // myScriptWindow
//////////////////
function myGetScriptPath() {
try { return app.activeScript; }
catch(e) { return File(e.fileName); }
}
/////
function mySpaceCalculation() {
try { myCurrPictName = myCurrPictFrame.allGraphics[0].itemLink.name; } // в ряде случаев при вставке объектов через буфер они не появляются в панели Links. 
catch (e) { myCurrPictName = null; } 	// поэтому будут учтены без контроля их повторного появления.	
if ( myLookingForCurrPictNameInArray(myCurrPictName) ==true ) return; // если иллюстрация с этим именем уже встречалась, она больше не учитывается	
myPictureWidth= myCurrPictFrame.geometricBounds[3] - myCurrPictFrame.geometricBounds[1];
myPictureHeight= myCurrPictFrame.geometricBounds[2] - myCurrPictFrame.geometricBounds[0];
mySpaceOfPictures += myPictureWidth*myPictureHeight;
myNumberOfPictures++;
return;
}
/////
function myLookingForCurrPictNameInArray(myCurrPictName) {
var myP = 0;
if (myCurrPictName == null) return(false); // если рисунок вставлен через буфер, и его нет в панели Links, он учитывается столько раз, сколько было таких вставок
for (j =0; j < myNamesOfAllPictures.length; j++) { //
	if (myNamesOfAllPictures[j] == myCurrPictName) { myP = 1; break; }
	}
if (myP == 1) return (true);
myNamesOfAllPictures.push(myCurrPictName);
return(false);
}

